% Create new data and observations with weights for original multiple observations
% NOTE: assumes doing L2 isotonic regression
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Inputs:  
% data:       n x m data matrix with n samples and m features
% y:          n x 1 vector of input observations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Outputs:  
% newdata:    unique data matrix where rows are unique 
% newy:       new observations
% weights:    weights for each unqieu data point
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modified by Ronny Luss, May 2011
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [newdata,newy,weights] = WeightedUniqueDataL2(data,y)

newdata=unique(data,'rows');
newy=zeros(size(newdata,1),1);
weights=zeros(size(newdata,1),1);
for i=1:size(newdata,1);
    inds=find(sum((ones(length(y),1)*newdata(i,:))~=data,2)==0); 
    newy(i)=mean(y(inds));
    weights(i)=length(inds);
end
