%  Computes the p-norm loss estimator on data y using binary search on derivatives 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Inputs:  
% y:           n x 1 input vector to isotonic regression, e.g. observations
% p:           input parameter for p-norm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Outputs:  
% x:           point estimator for p-norm loss
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modified by Ronny Luss, May 2011
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [x] = pnorm_estimator(y,p)


% BINARY SEARCH!!!
if p<2
   a=min(y);ind=find(a~=y);f_a=sum(p*abs((a-y(ind)).^(p-2)).*(a-y(ind)));
   c=max(y);ind=find(c~=y);f_c=sum(p*abs((c-y(ind)).^(p-2)).*(c-y(ind)));
    x=(a+c)/2;ind=find(x~=y);f_x=sum(p*abs((x-y(ind)).^(p-2)).*(x-y(ind)));
    while abs(a-c)>.000000001
        if sign(f_a)==sign(f_x)
           a=x;ind=find(a~=y);f_a=sum(p*abs((a-y(ind)).^(p-2)).*(a-y(ind)));
        else
            c=x;ind=find(c~=y);f_c=sum(p*abs((c-y(ind)).^(p-2)).*(c-y(ind)));
        end    
        x=(a+c)/2;ind=find(x~=y);f_x=sum(p*abs((x-y(ind)).^(p-2)).*(x-y(ind)));
    end
else
    a=min(y);f_a=sum(p*abs((a-y).^(p-2)).*(a-y));
    c=max(y);f_c=sum(p*abs((c-y).^(p-2)).*(c-y));
    x=(a+c)/2;f_x=sum(p*abs((x-y).^(p-2)).*(x-y));
    while abs(a-c)>.000000001
        if sign(f_a)==sign(f_x)
            a=x;f_a=sum(p*abs((a-y).^(p-2)).*(a-y));
        else
            c=x;f_c=sum(p*abs((c-y).^(p-2)).*(c-y));
        end    
        x=(a+c)/2;f_x=sum(p*abs((x-y).^(p-2)).*(x-y));
    end
end
% x=x*mult;